#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=700";
$confGanglia = "/etc/gmond.conf";

#die "Ganglia is not installed" if ! -r $confGanglia;

my $verbose = grep(/-v/,@ARGV);

my $gmetricDest = "";

if (-r $confGanglia)
  {
    my $ip;
    my $port;
    
    open(IN,"$confGanglia") || die "Cannot read $confGanglia";
    while (<IN>)
      {
        next if /^#/;
        $ip   = $1 if /mcast_channel +(.*)/;
        $port = $1 if /mcast_port +(.*)/;
      }
    close IN;
    
    $gmetricDest .= " -c$ip " if defined $ip;
    $gmetricDest .= " -p$port " if defined $port;
  }

$ENV{"TERM"} = "vt100";

my @top = split(/\n/,`top -b -n1`);

while(1)
  {
    $t = shift @top;
    last if ! defined $t;
    last if ($t =~ /^\s+PID/);
  }

$t =~ s/\s+/ /g;
my $type;
$type = 1 if $t =~ /PID USER PR NI VIRT RES SHR S \%CPU \%MEM TIME\+ COMMAND/;
$type = 2 if $t =~ /PID USER PR NI \%CPU TIME\+ \%MEM VIRT RES SHR S COMMAND/;

die "Unknown output from \'top\': $t\n" unless $type;

#print "$t\n";

for (my $i=1; ; $i++)
  {
    my $t = shift @top;
    last if ! $t;
    $t =~ s/^ *//; # remove leading spaces
    my @t = split(/ +/,$t);

    #print "top: $t\n";

    my ($user, $size, $rss, $cmd, $time, $mem, $cpu);

    if ($type == 1)
      {
        $user = $t[1];
        $size = $t[4];
        $rss  = $t[5];
        $cmd  = pop @t;
        $time = pop @t;
        $time = pop @t if !($time =~ /\:/);
        $mem  = pop @t;
        $cpu  = pop @t;
      }
    elsif ($type == 2)
      {
        $user = $t[1];
        $cpu  = $t[4];
        $time = $t[5];
        $mem  = $t[6];
        $size = $t[7];
        $rss  = $t[8];
        $cmd  = pop @t;
      }

    if (1)
      {
        if (uc($size) =~ /(.*)M/)
          {
            my $xsize = $1;
            $size = $xsize*1024;
          }

        if (uc($size) =~ /(.*)G/)
          {
            my $xsize = $1;
            $size = $xsize*1024*1024;
          }

        if (uc($rss) =~ /(.*)M/)
          {
            my $xsize = $1;
            $rss = $xsize*1024;
          }

        if (uc($rss) =~ /(.*)G/)
          {
            my $xsize = $1;
            $rss = $xsize*1024*1024;
          }

        $size = int(($size+1023)/1024);
        $rss  = int(($rss+1023)/1024);

        my $val  = "$user/$size"."M/".$rss."M/$cmd";

        $val =~ s/\</[/g;
        $val =~ s/\>/]/g;

        $mem{$val} = $size;
      }

    if ($i <= 5)
      {
        my $val  = "$user/$cpu/$time/$cmd";

        $val =~ s/\</[/g;
        $val =~ s/\>/]/g;
        
        my $exec = "$confGmetric $gmetricDest -tstring -n\"Top_$i\" -v\"$val\"";
        print "$exec\n" if $verbose;
        system $exec;
      }

    #die "Here!";
  }

my $i = 0;
foreach my $mem (sort { $mem{$b} <=> $mem{$a} } keys %mem)
  {
    $i++;
    #print "mem_$i $mem\n";

    if ($i <= 5)
      {
        my $exec = "$confGmetric $gmetricDest -tstring -n\"Mem_$i\" -v\"$mem\"";
        print "$exec\n" if $verbose;
        system $exec;
      }
  }

exit 0;
#end file
